"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _listr = _interopRequireDefault(require("listr"));

var _execa = _interopRequireDefault(require("execa"));

var _commander = _interopRequireDefault(require("commander"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function build({
  web = true,
  node = true
} = {}) {
  return new _listr.default([{
    title: 'node',
    skip: () => !node,

    async task(outputs) {
      const output = await (0, _execa.default)('babel', ['src', '--out-dir', 'lib', '--config-file', _path.default.resolve(__dirname, 'babel.config.js'), '--copy-files', '--delete-dir-on-start', '--no-babelrc', '--source-maps', '--verbose'], {
        env: { ...process.env,
          NODE_ENV: 'production'
        }
      });
      outputs.push(output);
      return output;
    }

  }, {
    title: 'web',
    skip: () => !web,

    async task(outputs) {
      const output = await (0, _execa.default)('react-scripts', ['build', '--color'], {
        env: { ...process.env,
          SKIP_PREFLIGHT_CHECK: true
        }
      });
      outputs.push(output);
      return output;
    }

  }], {
    renderer: process.env.NODE_ENV === 'test' ? 'silent' :
    /* istanbul ignore next */
    'default',
    exitOnError: false,
    concurrent: true
  }).run([]);
}
/* istanbul ignore next line */


if (require.main === module) {
  _commander.default.option('--no-web').option('--no-node').parse(process.argv);

  build(_commander.default).then(outputs => {
    // eslint-disable-line promise/prefer-await-to-then
    outputs.filter(({
      stdout
    }) => stdout).forEach(({
      stdout
    }) => console.log(stdout)); // eslint-disable-line no-console

    return outputs;
  }).catch(err => {
    // eslint-disable-line promise/prefer-await-to-callbacks
    const {
      errors = []
    } = err;
    /* istanbul ignore next line */

    errors.filter(({
      stdout
    }) => stdout).forEach(({
      stdout
    }) => console.log(stdout)); // eslint-disable-line no-console

    /* istanbul ignore next line */

    errors.filter(({
      stderr
    }) => stderr).forEach(({
      stderr
    }) => console.error(stderr)); // eslint-disable-line no-console

    process.exit(err.code || (errors.find(({
      code
    }) => code) || {}).code || 1);
  });
}

var _default = build;
exports.default = _default;
//# sourceMappingURL=react-node-scripts-build.js.map